CVSTrac Malformed URI Infinite Loop DoS

2004-08-17T00:00:00
ID CVSTRAC_MALFORMED_URI_DOS.NASL
Type nessus
Reporter Tenable
Modified 2013-01-25T00:00:00

Description

The remote host seems to be running cvstrac, a web-based bug and patch-set tracking system for CVS.

This version contains a flaw related to the parameter parser that may allow an attacker to create a malformed URL, which causes the application to hang. An attacker, exploiting this flaw, would only need network access to the cvstrac server. Upon sending a malformed link, the cvstrac server would go into an infinite loop, rendering the services as unavailable.

* Nessus has determined the vulnerability exists on the target simply by looking at the version number(s) of CVSTrac ** installed there.

                                        
                                            #
# (C) Tenable Network Security, Inc.
#

include("compat.inc");

if (description)
{
 script_id(14289);
 script_version("$Revision: 1.12 $");
 script_cvs_date("$Date: 2013/01/25 01:19:07 $");

 script_osvdb_id(8646);

 script_name(english:"CVSTrac Malformed URI Infinite Loop DoS");
 script_summary(english:"Checks for CVSTrac version");

 script_set_attribute(attribute:"synopsis", value:
"The remote web server is hosting a CGI application that is affected
by a denial of service vulnerability.");
 script_set_attribute(attribute:"description", value:
"The remote host seems to be running cvstrac, a web-based bug and 
patch-set tracking system for CVS.

This version contains a flaw related to the parameter parser that may
allow an attacker to create a malformed URL, which causes the 
application to hang.  An attacker, exploiting this flaw, would only
need network access to the cvstrac server.  Upon sending a malformed 
link, the cvstrac server would go into an infinite loop, rendering the
services as unavailable.

***** Nessus has determined the vulnerability exists on the target
***** simply by looking at the version number(s) of CVSTrac
***** installed there.");
 script_set_attribute(attribute:"see_also", value:"http://www.cvstrac.org/cvstrac/chngview?cn=233");
 script_set_attribute(attribute:"solution", value:
"Update to version 1.1.4 or later as this reportedly fixes the issue.");
 script_set_cvss_base_vector("CVSS2#AV:N/AC:L/Au:N/C:N/I:N/A:P");

 script_set_attribute(attribute:"plugin_publication_date", value:"2004/08/17");
 script_set_attribute(attribute:"vuln_publication_date", value:"2002/11/30");

 script_set_attribute(attribute:"plugin_type", value:"remote");
 script_end_attributes();

 script_category(ACT_ATTACK);
 script_copyright(english:"This script is Copyright (C) 2004-2013 Tenable Network Security, Inc.");
 script_family(english:"CGI abuses");

 script_dependencie("find_service1.nasl", "http_version.nasl");
 script_require_ports("Services/www", 80);
 exit(0);
}

#
# The script code starts here
#

include("global_settings.inc");
include("http_func.inc");

port = get_http_port(default:80);
kb = get_kb_item("www/" + port + "/cvstrac" );
if ( ! kb ) exit(0);
stuff = eregmatch(pattern:"(.*) under (.*)", string:kb );
version = stuff[1]; 
if(ereg(pattern:"^(0\.|1\.(0|1\.[0-3]([^0-9]|$)))", string:version))
	security_warning(port);